lib = File.expand_path('../lib', __FILE__)
$LOAD_PATH.unshift(lib) if File.directory?(lib) && !$LOAD_PATH.include?(lib)

require 'thor'
require 'highline'

require 'json'
require 'yaml'
require 'fileutils'
require 'rubygems/package'
require 'active_support/core_ext/object'
require 'active_support/inflector'

autoload :Linguist, 'linguist'

require 'devpad/configuration'
require 'devpad/api'
require 'devpad/account'
require 'devpad/user'
require 'devpad/exception'
require 'devpad/client'
require 'devpad/version'

require 'devpad/cli'

require 'devpad/app'

Devpad::User.load!
Devpad::Account.load!

Devpad::Configuration.configure do |config|
  config.user_agent = 'Devpad CLI Ruby'
  config.user_api_key = Devpad::User.auth_token
  config.api_version = '1'
  config.endpoint = ENV['DEVPAD_API_ENDPOINT'] || 'https://cli.devpad.io'
end
