module Devpad
  class Account
    def self.load!
      FileUtils.mkdir_p("#{Dir.home}/.devpad")
      if File.exist?("#{Dir.home}/.devpad/account")
        self.current = File.read("#{Dir.home}/.devpad/account")
      end
    end

    def self.save!
      FileUtils.mkdir_p("#{Dir.home}/.devpad")

      File.open("#{Dir.home}/.devpad/account", 'w') do |f|
        f.write(self.current)
      end
    end

    def self.current!
      if @current.nil?
        raise Devpad::Exception.new, 'No account selected.'
      end
      @current
    end

    def self.current
      @current
    end

    def self.current=(cur)
      @current = cur
    end
  end
end