module Devpad
  module API
    class Client
      def self.instance
        options = {
            endpoint: Devpad::Configuration.instance.endpoint,
            api_version: Devpad::Configuration.instance.api_version,
            user_agent: Devpad::Configuration.instance.user_agent,
            user_api_key: Devpad::Configuration.instance.user_api_key,
            api_format: 'json'
        }
        @client ||= Devpad::Client.new(options)
      end

      def self.reset_instance
        @client = nil
        instance
      end

      def self.download(endpoint, to, params = {})
        instance.download(endpoint, to, params)
      end

      def self.get(endpoint, params = {})
        instance.get(endpoint, params)
      end

      def self.post(endpoint, params = {})
        instance.post(endpoint, params)
      end

      def self.put(endpoint, params = {})
        instance.post(endpoint, params.merge(_method: 'PUT'))
      end

      def self.delete(endpoint, params = {})
        instance.post(endpoint, params.merge(_method: 'DELETE'))
      end
    end
  end
end
