module Devpad
  module API
    class Pad < OpenStruct
      def self.all(params = {})
        @response = Devpad::API::Client.get("/accounts/#{Devpad::Account.current!}/pads", params)
        @response['data'].map do |item|
          new(item['attributes'].merge('id' => item['id']).merge('user_name' => item.dig('relationships', 'user', 'data', 'attributes', 'name')))
        end
      end

      def self.create(params = {})
        @response = Devpad::API::Client.post("/accounts/#{Devpad::Account.current!}/pads", params)
        item = @response['data']
        new(item['attributes'].merge('id' => item['id']).merge('user_name' => item.dig('relationships', 'user', 'data', 'attributes', 'name')))
      end

      def self.clone(params = {})
        pad_id = params.delete :id
        @response = Devpad::API::Client.post("/accounts/#{Devpad::Account.current!}/pads/#{pad_id}/clone", params)
        item = @response['data']
        new(item['attributes'].merge('id' => item['id']).merge('user_name' => item.dig('relationships', 'user', 'data', 'attributes', 'name')))
      end

      def self.close(params = {})
        pad_id = params.delete :id
        @response = Devpad::API::Client.post("/accounts/#{Devpad::Account.current!}/pads/#{pad_id}/close", params)
        item = @response['data']
        new(item['attributes'].merge('id' => item['id']).merge('user_name' => item.dig('relationships', 'user', 'data', 'attributes', 'name')))
      end

      class User < OpenStruct
        def self.update(params = {})
          pad_id = params.delete :id
          @response = Devpad::API::Client.put("/accounts/#{Devpad::Account.current!}/pads/#{pad_id}/user", params)
          item = @response['data']
          Pad.new(item['attributes'].merge('id' => item['id']).merge('user_name' => item.dig('relationships', 'user', 'data', 'attributes', 'name')))
        end
      end

      class Link < OpenStruct
        def self.create(params = {})
          pad_id = params.delete :id
          @response = Devpad::API::Client.post("/accounts/#{Devpad::Account.current!}/pads/#{pad_id}/link", params)
          item = @response['data']
          new(item['attributes'].merge('id' => item['id']))
        end
      end

      class Invitation < OpenStruct
        def self.create(params = {})
          pad_id = params.delete :id
          @response = Devpad::API::Client.post("/accounts/#{Devpad::Account.current!}/pads/#{pad_id}/invitation", params)
          item = @response['data']
          new(item['attributes'].merge('id' => item['id']))
        end
      end
    end
  end
end
