module Devpad
  module API
    class Snippet < OpenStruct
      def self.all(params = {})
        @response = Devpad::API::Client.get("/accounts/#{Devpad::Account.current!}/snippets", params)
        @response['data'].map do |item|
          new(item['attributes'].merge('id' => item['id']))
        end
      end

      def self.create(params = {})
        @response = Devpad::API::Client.post("/accounts/#{Devpad::Account.current!}/snippets", params)
        item = @response['data']
        new(item['attributes'].merge('id' => item['id']))
      end

      def self.delete(params = {})
        snippet_id = params.delete(:id)
        @response = Devpad::API::Client.delete("/accounts/#{Devpad::Account.current!}/snippets/#{snippet_id}", params)
        item = @response['data']
        new(item['attributes'].merge('id' => item['id']))
      end
    end
  end
end
