module Devpad
  class App < Thor
    map '-v' => :version
    desc 'version', 'Devpad CLI Version'
    def version
      shell.say Devpad::VERSION
    end

    desc 'login', 'Login'
    def login
      if Devpad::CLI::Commands::User::Login.new(shell: shell).execute
        shell.say 'Success. Done.'
      else
        shell.say 'Invalid login or password.'
      end
    end

    desc 'reset', 'Reset'
    def reset
      Devpad::CLI::Commands::User::Reset.new(shell: shell).execute
    end

    desc 'install', 'Setup configuration'
    def install
      Devpad::CLI::Commands::User::Reset.new(shell: shell).execute
      Devpad::CLI::Commands::User::Login.new(shell: shell).execute
      Devpad::CLI::Commands::Account::Select.new(shell: shell).execute
    end

    desc 'account [COMMAND]', 'Manage accounts'
    subcommand 'account', Devpad::CLI::Account

    desc 'image [COMMAND]', 'Manage images'
    subcommand 'image', Devpad::CLI::Image

    desc 'pad [COMMAND]', 'Manage pads'
    subcommand 'pad', Devpad::CLI::Pad

    desc 'review [COMMAND]', 'Manage reviews'
    subcommand 'review', Devpad::CLI::Review

    desc 'repository [COMMAND]', 'Manage repositories'
    subcommand 'repository', Devpad::CLI::Repository

    #desc 'test_suite [COMMAND]', 'Manage test suites'
    #subcommand 'test_suite', Devpad::CLI::TestSuite

    desc 'snippet [COMMAND]', 'Manage snippets'
    subcommand 'snippet', Devpad::CLI::Snippet

    desc 'language [COMMAND]', 'Manage languages'
    subcommand 'language', Devpad::CLI::Language
  end
end
