module Devpad
  module CLI
    module Commands
      module Account
        class Select
          def initialize(shell:)
            @cli = HighLine.new
            @shell = shell
          end

          def execute
            Devpad::Account.current = @cli.choose do |menu|
              Choose.new(menu: menu).perform
            end
            Devpad::Account.save!
            Display.new(shell: @shell).perform if @shell.present?
          end

          class Choose
            def initialize(menu:)
              @menu = menu
            end

            def perform
              @menu.prompt = 'Please select your current account'
              Devpad::API::Account.all.map do |account|
                @menu.choice(account.subdomain, nil, "#{account.name} (#{account.subdomain})")
              end
            end
          end

          class Display
            def initialize(shell:)
              @shell = shell
            end

            def perform
              @shell.say "Selected #{Devpad::Account.current} as current account"
            end
          end
        end
      end
    end
  end
end
