module Devpad
  module CLI
    module Commands
      module Repository
        module Branch
          class List
            def initialize(shell:)
              @shell = shell
            end

            def execute(params = {})
              rows = Devpad::API::Repository::Branch.all(params).each_with_index.map do |branch, index|
                [index + 1, branch.name, branch.token]
              end
              @shell.print_table rows
              @shell.say "(Page #{params['page']})"
            end
          end
        end
      end
    end
  end
end
