module Devpad
  module CLI
    module Commands
      module Repository
        module Commit
          class List
            def initialize(shell:)
              @shell = shell
            end

            def execute(params = {})
              rows = Devpad::API::Repository::Commit.all(params).each_with_index.map do |commit, index|
                [index + 1, commit.sha, "#{commit.author_name} <#{commit.author_email}>", commit.message]
              end
              @shell.print_table rows
              @shell.say "(Page #{params['page']})"
            end
          end
        end
      end
    end
  end
end
