module Devpad
  module CLI
    module Commands
      module Repository
        class List
          def initialize(shell:)
            @shell = shell
          end

          def execute(params = {})
            rows = Devpad::API::Repository.all(params).each_with_index.map do |pad, index|
              [index + 1, pad.name, pad.user_name, pad.token, pad.status]
            end
            @shell.print_table rows
            @shell.say "(Page #{params['page']})"
          end
        end
      end
    end
  end
end
