module Devpad
  module CLI
    module Commands
      module Review
        module File
          class List
            def initialize(shell:)
              @shell = shell
            end

            def execute(params = {})
              rows = Devpad::API::Review::File.all(params).each_with_index.map do |file, index|
                locked = file.locked ? 'locked': ''
                hidden = file.hidden ? 'hidden': ''
                [index + 1, file.name, file.language, locked, hidden]
              end
              @shell.print_table rows
              @shell.say "(Page #{params['page']})"
            end
          end
        end
      end
    end
  end
end
