module Devpad
  module CLI
    module Commands
      module Review
        class List
          def initialize(shell:)
            @shell = shell
          end

          def execute(params = {})
            rows = Devpad::API::Review.all(params).each_with_index.map do |review, index|
              [index + 1, review.name, review.user_name, review.token, review.status]
            end
            @shell.print_table rows
            @shell.say "(Page #{params['page']})"
          end
        end
      end
    end
  end
end
