module Devpad
  module CLI
    module Commands
      module Review
        class User
          def initialize(shell:)
            @shell = shell
            @cli = HighLine.new
          end

          def execute(params = {})
            user_id = @cli.choose do |menu|
              Choose.new(menu: menu).perform
            end
            review = Devpad::API::Review::User.update(params.merge(object_id: user_id))
            @shell.say review.user_name
          end

          class Choose
            def initialize(menu:)
              @menu = menu
            end

            def perform
              @menu.prompt = 'Please select new user'
              Devpad::API::Account::User.all.map do |user|
                @menu.choice(user.id, nil, "#{user.name} (#{user.role})")
              end
            end
          end
        end
      end
    end
  end
end
