module Devpad
  module CLI
    module Commands
      module Snippet
        class List
          def initialize(shell:)
            @shell = shell
          end

          def execute(params = {})
            rows = Devpad::API::Snippet.all(params).each_with_index.map do |snippet, index|
              [index + 1, snippet.name, snippet.language, "#{snippet.number_of_lines} lines"]
            end
            @shell.print_table rows
            @shell.say "(Page #{params['page']})"
          end
        end
      end
    end
  end
end
