module Devpad
  module CLI
    module Commands
      module User
        class Login
          def initialize(shell:)
            @shell = shell
            @cli = HighLine.new
          end

          def execute
            @shell.say 'Sign-in to Devpad'

            email    = @cli.ask('Enter your e-mail: ')
            password = @cli.ask('Enter your password: ') { |q| q.echo = '*' }

            if email.present? && password.present?
              return false if (auth_token = Devpad::API::User.authenticate(email, password)).blank?
              Devpad::User.auth_token = auth_token
              Devpad::User.save!
              Devpad::Configuration.instance.user_api_key = Devpad::User.auth_token
              Devpad::API::Client.reset_instance
              return true
            end
            false
          end
        end
      end
    end
  end
end
