module Devpad
  module CLI
    class Image < Thor
      option :name, type: :string, required: true
      option :version, type: :string
      option :base, type: :string
      option :language, type: :string
      option :type, type: :string, enum: %w(pad review repository test_suite), default: 'pad'
      option :description, type: :string
      option :entrypoint, type: :string
      option :repl, type: :boolean
      option :private, type: :boolean
      desc 'create', 'Create an image'
      def create(path = '.')
        params = options.slice('name', 'version', 'base', 'type', 'description', 'entrypoint', 'repl', 'private')
        params['path'] = path
        if options[:language].present?
          language_id = Integer(options[:language]) rescue nil
          if language_id.nil?
            params['language_id'] = Linguist::Language.find_by_name(options[:language])&.language_id
          end
        else
          params['language_id'] = nil
        end
        Devpad::CLI::Commands::Image::Create.new(shell: shell).execute(params)
      end
    end
  end
end
