module Devpad
  module CLI
    class Snippet < Thor
      option :page, type: :numeric, default: 1
      desc 'list', 'List of available snippets'
      def list
        params = { 'page' => options[:page] }
        Devpad::CLI::Commands::Snippet::List.new(shell: shell).execute(params)
      end

      option :name, type: :string, default: nil
      option :description, type: :string, default: nil
      option :language, type: :string, default: nil
      desc 'upload [FILE]', 'Create a snippet'
      def upload(path)
        if File.exist?(path)
          name = options[:name] || File.basename(path)
          if options[:language].present?
            language_id = Integer(options[:language]) rescue nil
            if language_id.nil?
              language_id = Linguist::Language.find_by_name(options[:language])&.language_id
            end
          else
            language_id = Linguist::Language.find_by_extension(File.extname(name))&.first&.language_id
          end
          params = {
            snippet: {
              name: name,
              description: options[:description],
              language_id: language_id,
              content: File.read(path)
            }
          }
          Devpad::CLI::Commands::Snippet::Create.new(shell: shell).execute(params)
        else
          shell.error "File `#{path}' does not exist."
        end
      end
    end
  end
end
